/**********************************************************************
    errores.h
  
    RealNumbers  1.0
    Copyright (C) 1997  Antonio Larrosa Jimenez

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
***********************************************************************/
#ifndef ERRORES_H
#define ERRORES_H

enum Tipo_Error { No_hay_error = 1, Division_x_cero = 2, Cociente_periodico = 3,
                    Rango_infinito = 4 , Rango_mas_infinito = 5,
                    Rango_menos_infinito = 6, Posible_Division_x_cero = 7,
                    Raiz_de_numero_negativo = 8}; 
/* Estos son los posibles errores que pueden ocurrir al dividir dos numeros :
    No_hay_error = Eso mismo
    Division_x_cero = Se ha intentado dividir entre 0 , en ese caso el resultado
                de la division es 0 y el objeto resultado tiene este error
    Cociente_periodico = Si al dividir no se puede tener toda la precision que
                se quisiera (porque MAX_CIFRAS_DEC es muy pequeo o porque
                la division da un numero periodico como 10/3 ) entonces el
                resultado es aproximado y tiene este error
    Rango_infinito = Cuando se dividen dos numeros con errores y el divisor
                puede hacerse todo lo pequeo que se quiera y de cualquier signo,
                la division puede ser cualquier numero, esto se indica poniendo
                este error en el resultado
    Rango_mas_infinito = En una division como 40.1 / 0.10.1 el resultado
                puede estar entre 19.5 (3.9/0.2) y +Infinito por lo que el resultado
                es 19.5  0.0  y un error de Rango_mas_infinito
    Rango_menos_infinito = Igual que antes . Pero veamos otro ejemplo:
                -40.1 / -0.10.1 el resultado esta entre 19.5 (-3.9/-0.2) y
                -Infinito por lo que el resultado es 19.5  0.0 y un error de
                Rango_menos_infinito   
    Posible_division_x_cero = Cuando se divide 0 entre cualquier numero, el
                resultado es 0 siempre, excepto cuando el divisor es 0,
                por ello, hay casos en los que por no conocer el divisor exacto
                se puede estar dividiendo 0 entre 0 en este caso devuelve este
                error en el resultado 
    Raiz_de_numero_negativo = Cuando se hace la raiz de un numero negativo
*/

#endif
