/********************************************************************
Archivo ... MAIN.CPP
Contenido . La funcion main del programa de prueba
Fecha ..... 21-3-97
Comentario. Define NUMERO ,NUMEROZ o NUMEROQ, NUMEROE para que la prueba sea
            la clase Numero, la clase NumeroZ o la clase NumeroQ.

*********************************************************************/

#include "messbox.h"
#include <string.h>
#include "newdebug.h"
#include <stdio.h>
#include <stream.h>
#include "mathfunc.cc"
#include <unistd.h>

ulong MAX_CIFRAS_DEC=30;

#if defined (NUMERO)
   #include "numero.h"
   #define CLASE_DE_PRUEBA "Numero"
   #define OPERACIONES "\nEscriba la operacion que quiera realizar \n( + - * / ! sqrt ++ -- << >> < > <= >= == != ) : "
   #define OP_DESPLAZA
   #define OP_FACTORIAL
#elif defined (NUMEROZ)
   #include "numeroz.h"
   #define CLASE_DE_PRUEBA "NumeroZ"
   #define OPERACIONES "\nEscriba la operacion que quiera realizar \n( + - * / %% ! sqrt mcd ++ -- << >> < > <= >= == != ) : "
   #define OP_DESPLAZA
   #define OP_FACTORIAL
   #define OP_MODULO
   #define OP_MCD
#elif defined (NUMEROQ)
   #include "numeroq.h"
   #define CLASE_DE_PRUEBA "NumeroQ"
   #define OPERACIONES "\nEscriba la operacion que quiera realizar \n( + - * / sqrt ++ -- < > <= >= == != ) : "
#elif defined (NUMEROE)
   #include "numeroe.h"
   #define CLASE_DE_PRUEBA "NumeroE"
   #define OPERACIONES "\nEscriba la operacion que quiera realizar \n( + - * / sqrt ++ -- << >> < > <= >= == != ) : "
   #define OP_DESPLAZA
#endif

Cifra BASE_N=10;

bool Es_operacion(char *s)
{
   if (strcmp(s,"sqrt")==0) return SI;
#ifdef OP_MCD
   if (strcmp(s,"mcd")==0) return SI;
#endif
   if (s[1]==0)
      {
      if (s[0]=='+') return SI;
      if (s[0]=='-') return SI;
      if (s[0]=='*') return SI;
      if (s[0]=='/') return SI;
#ifdef OP_MODULO
      if (s[0]=='%') return SI;
#endif


#ifdef OP_FACTORIAL
      if (s[0]=='!') return SI;
#endif
      if (s[0]=='>') return SI;
      if (s[0]=='<') return SI;
      return NO;
      };
   if (s[2]==0)
      {
      if ((s[0]=='+')&&(s[1]=='+')) return SI;
      if ((s[0]=='-')&&(s[1]=='-')) return SI;
#ifdef OP_DESPLAZA
      if ((s[0]=='<')&&(s[1]=='<')) return SI;
      if ((s[0]=='>')&&(s[1]=='>')) return SI;
#endif

      if (s[1]=='=')
         {
         if (s[0]=='=') return SI;
         if (s[0]=='!') return SI;
         if (s[0]=='<') return SI;
         if (s[0]=='>') return SI;
         return NO;
         };
      return NO;
      };
   return NO;
};



bool Es_relacion(char *s)
{
   if (s[1]==0)
      {
      if (s[0]=='>') return SI;
      if (s[0]=='<') return SI;
      return NO;
      };
   if (s[2]==0)
      {
      if (s[1]=='=')
         {
         if (s[0]=='=') return SI;
         if (s[0]=='!') return SI;
         if (s[0]=='<') return SI;
         if (s[0]=='>') return SI;
         return NO;
         };
      return NO;
      };
   return NO;
};

int Numero_de_operandos(char *s)
// Devuelve el numero de operandos y -1 si la operacion es << o >> (desplazar)
//   que necesita un parametro integer
{
   if (strcmp(s,"sqrt")==0) return 1;
   if ((s[0]=='!')&&(s[1]==0)) return 1;
   if ((s[0]=='+')&&(s[1]=='+')&&(s[2]==0)) return 1;
   if ((s[0]=='-')&&(s[1]=='-')&&(s[2]==0)) return 1;
#ifdef OP_DESPLAZA
   if ((s[0]=='<')&&(s[1]=='<')) return -1;
   if ((s[0]=='>')&&(s[1]=='>')) return -1;
#endif
   return 2;
};



int main(int argc,char **argv)
{
  int interactivo=NO;
  int i,error=NO;
  extern char *optarg;
  extern int optind;
  int indice;

#ifdef FMALLOC_ACTIVE
  NewDbg::Inicializa_fmalloc();
#endif
  LogFile=NULL;
  while ((i = getopt( argc, argv, "dia:b:")) != -1)
	switch (i) {
	case 'd' : 
		printf("Un fichero de Log creado\n");
		char d[20];
		sprintf(d,"numero.log");
		LogFile=fopen(d,"wt");
#ifdef HARDLOG
		setbuf(LogFile,NULL);
#endif
		break;
	case 'b' : 
		BASE_N = atoi(optarg);
		if ((BASE_N<2)||(BASE_N>36))
			{
			printf("Error : La base debe estar entre 2 y 36\n");
			exit(1);
			};
		break;
	case 'i' : interactivo++;break;
	default :
		error=SI;
		break;
	};
printf( "Programa de prueba para la clase ""%s"" usando base %d.\n"
	"Libreria RealNumbers  (C) 1997 . Antonio Larrosa Jimnez .  Mlaga.\n"
	,CLASE_DE_PRUEBA,BASE_N);
if ((error==SI))
	{
	printf("uso : \n"
		" %s [Opciones] [Cuentas] \n"
		" ""Cuentas"" : Es una serie de numeros y operaciones separados por espacios\n"
		" ""Opciones"" : Pueden ser las siguientes opciones :\n"
		"\n"
		"	-d	Crea un fichero en el que se guardan todos los pasos\n"
		"	-b x	Usa el programa con base x\n"
		"	-i	Entra en el modo interactivo\n",argv[0]);
	exit(1);
	};
Checkpoint_control(0,"");
#ifdef FMALLOC_ACTIVE
  NewDbg::ShowStatus();
#endif
  if (LogFile!=NULL) Checkpoint("Archivo creado");



{
/* Esta llave est aqu porque las siguientes variables se crean localmente
 (en vez de con new) y quiero que se destruyan antes de llamar a la funcion
 NewDbg::ShowStatus() del final que dice si ha habido memoria sin liberar
 y esas cosas, por eso, pongo esta llave aqui y cierro el scope antes de
 llamar a la funcion de debugeo con lo que las variables se destruyen antes */

#if defined (NUMEROQ)
NumeroQ a;
NumeroQ b;
NumeroQ c;
#elif defined (NUMEROZ)
NumeroZ a;
NumeroZ b;
NumeroZ c;
#elif defined (NUMERO)
Numero a;
Numero b;
Numero c;
#elif defined (NUMEROE)
NumeroE a;
NumeroE b;
NumeroE c;
#endif

char op[15];
char *s=(char *)fmalloc(20000,0);
char *s1=(char *)fmalloc(200000,0);
printf("Dame un numero :\n");
indice = optind;
if (indice<argc)
	{
	strcpy(s,argv[indice]);
	indice++;
	printf("%s\n",s);
	} 
       else 
	{
	gets(s);
	};
printf(".");
a=s;
printf(".\n");
a.Convierte_a_cadena(s1);
printf(".\n");
//a=((Numero)1)/((Numero)10);
    // 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901
    //          10        20        30        40        50        60        70        80        90        100
char *sr=(char *)fmalloc(200000,0);
char k;
char *s2=(char *)fmalloc(200000,0);
bool fin=NO;
int entero=0;
while (!fin)
{
if (NO==interactivo) fin=SI;

printf(OPERACIONES);
if (indice<argc)
	{
	strcpy(op,argv[indice]);
	indice++;
	printf("%s\n",op);
	}
       else
	{
	gets(op);
	};

k=op[0];
while ((!Es_operacion(op))&&(op[0]!=0))
   {
   gets(op);
   };
if (op[0]==0) {printf("\nAdios !\n");fin=SI;return 0;};
if (Numero_de_operandos(op)==2)
   {
   printf("Dame otro numero :\n");
   if (indice<argc)
	{
	strcpy(s,argv[indice]);
	indice++;
	printf("%s\n",s);
	} 
       else 
	{
	gets(s);
	};
   printf(".");
   b=s;
   printf(".");
   b.Convierte_a_cadena(s2);
   printf(".\n");
   cout << "1) " << a << endl << "2) " << b << endl;
   }
  else
   if (Numero_de_operandos(op)==-1)
      {
      printf("Dame un int :\n");
      if (indice<argc)
	{
	strcpy(s,argv[indice]);
	indice++;
	printf("%s\n",s);
	} 
       else 
	{
	gets(s);
	};
      entero=atoi(s);
      }
     else
      {
      cout << "1) " << a << endl;
      };

if (op[1]=='=')
   {
   c=a;
   switch (op[0])
      {
      case '<' : strcpy(sr,(a<=b)?("SI"):("NO"));break;
      case '>' : strcpy(sr,(a>=b)?("SI"):("NO"));break;
      case '=' : strcpy(sr,(a==b)?("SI"):("NO"));break;
      case '!' : strcpy(sr,(a!=b)?("SI"):("NO"));break;
      default  : printf("\nAdios !\n");
      };
   }
  else
#ifdef OP_DESPLAZA
   if (strcmp(op,"<<")==0) {c=a;c<<=entero;}
  else
   if (strcmp(op,">>")==0) {c=a;c>>=entero;}
  else
#endif
   switch (op[0])
      {
      case '+' : if (op[1]=='+')
                    {
                    c=a;
                    c++;
                    }
                   else
                    c=a+b;
                 break;
      case '-' : if (op[1]=='-')
                    {
                    c=a;
                    c--;
                    }
                   else
                    c=a-b;
                 break;
      case '*' : c=a*b;break;
      case '/' : c=a/b;break;
#ifdef OP_MODULO
      case '%' : c=a%b;break;
#endif
#ifdef OP_FACTORIAL
      case '!' : c=a.Factorial();break;
#endif
      case 's'/*sqrt*/ : c=Sqrt(a);break;
#ifdef OP_MCD
      case 'm'/*mcd*/ : c=a.MCD(b);break;
#endif
      case '<' : c=a;strcpy(sr,(a<b)?("SI"):("NO"));break;
      case '>' : c=a;strcpy(sr,(a>b)?("SI"):("NO"));break;
      default : printf("\nAdios !\n");
      };

if (Es_relacion(op))
   {
   printf("%s %s %s \n",s1,op,s2);
   printf("%s",sr);
   }
  else
   if (Numero_de_operandos(op)==-1)
      {
      c.Convierte_a_cadena(sr);
      printf("%s %s %d = \n",s1,op,entero);
      printf(" = %s\n",sr);
      }
     else
      {
      c.Convierte_a_cadena(sr);
      if (Numero_de_operandos(op)==2) printf("%s %s %s = \n",s1,op,s2);
         else printf("%s %s = \n",s1,op);
      cout << " = " << c << endl;
      };
if (interactivo)
   {
   a=c;
   a.Convierte_a_cadena(s1);
   };
};
ffree(sr);
ffree(s1);
ffree(s2);
ffree(s);

printf("\n");

}; // Aqui se destruyen las variables a, b y c

  Checkpoint_control(100,"Fin de la sesin de prueba.");

#ifdef FMALLOC_ACTIVE
  NewDbg::ShowStatus();
#endif
  if (LogFile!=NULL) fclose(LogFile);


return 0;
};


