/**********************************************************************
    mathfunc.h  -- Algunas rutinas que usan a los numeros
  
    RealNumbers  1.0
    Copyright (C) 1997  Antonio Larrosa Jimenez

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
***********************************************************************/
#include "mathfunc.h"

#define NUM_ITERACIONES 10
#define DECIMALES_EN_RESULTADO 60

template <class T>
T Sqrt(T &n)
{
T x;
T Cero;
if (n<Cero) {x.SetErrorFlag(Raiz_de_numero_negativo);return x;};
T Dos;++Dos;++Dos;
T x2;
x=n/Dos;    // punto inicial
T tmp;
#ifdef NUMEROE
T Uno;++Uno;
T MenosUno;--MenosUno;
#endif

ulong i=NUM_ITERACIONES;
while (i>0)
    {
#ifdef DEBUG
    cout << x << endl;
#endif
    tmp=x*Dos;
    x2=x*x;
    x2=x2+n;
    x2=x2/tmp;

    //x2=((x*x)+n)/tmp;
    x2.Precision(DECIMALES_EN_RESULTADO);
    tmp=x-x2;
    tmp<<=DECIMALES_EN_RESULTADO;
/* Los siguientes #ifdef de hacen para acelerar cada tipo de numero en la 
   comparacion, pero en el fondo, todos hacen lo mismo, comparar que el
   valor absoluto de la resta desplazada sea menor que 1 */
#if defined(NUMEROQ)
    if (*(tmp.Num())<*(tmp.Den())) break; 
       else x=x2;
#elif defined(NUMEROE)
    if (((tmp>MenosUno))&&((tmp<Uno))) break;
       else x=x2;
#else
    if (tmp.NPE()==0) break;
       else x=x2;
#endif
    //i--;    
    }; 
return x;
};
