/*
Archivo ... NEWDEBUG.CPP
Clase ..... NewDbg
Contenido . Las implementaciones de new,delete,fmalloc y ffree
            Con este archivo los leakages de memoria ya no son problema ninguno
Fecha ..... 31/7/96 (new/delete) 1/8/96 (fmalloc,ffree)
Version ... 1.1
Cambios ... Ahora los fmalloc usan un ID para diferenciar mejor en que parte
            del programa pierde memoria (si la pierde)
Comentario. Si no se define CHECKPOINTS_EN_MALLOC, no aparecer ni un Checkpoint
            ni aunque salga un error en los fmalloc,new,delete o ffree
            Definiendo PRINTF_EN_NEWDBG aparecern en printf lo mismo que el
            ShowStatus manda al Checkpoint
            Asi, si no se define ninguno de los dos, ShowStatus no hace nada
            Hay que llamar a Inicializa_fmalloc al principio del programa (lo
            primero)
            Si se define SUPERMEMDEBUG se va guardando la cantidad mayor de
            memoria de cada ID que se ha tenido allocateada en un momento dado
            asi se hacen mejor las estadisticas
*/
#include "newdebug.h"
#ifdef FMALLOC_ACTIVE
#include <stdlib.h>
#include <malloc.h>
#include <stdio.h>

#define CHECKPOINTS_EN_MALLOC
//#define PRINTF_EN_NEWDBG
#define MACROMEM_DEBUG

//#ifdef CHECKPOINTS_EN_MALLOC
#include "messbox.h"
//#endif

//S stat1c 1n1tralizat1ons

long NewDbg::CountNew = 0;
long NewDbg::BytesNew = 0;
long NewDbg::CountMalloc[100];
long NewDbg::BytesMalloc[100];
bool NewDbg::UsadoMalloc[100];


#ifdef SUPERMEMDEBUG
long NewDbg::BiggestCountNew = 0;
long NewDbg::BiggestBytesNew = 0;
long NewDbg::BiggestCountMalloc[100];
long NewDbg::BiggestBytesMalloc[100];
#endif
/*NewDbg::NewDbg()
{
printf("aqui");
};

NewDbg::~NewDbg()
{
ShowStatus();
printf("NewDbg.  New .Count",NewDbg::GetCountN());
printf("NewDbg.  New .Bytes",NewDbg::GetBytesN());
for (int i=0;i<100;i++)
   {
   if (NewDbg::UsadoMalloc[i]==SI)
      {
      printf("NewDbg.Malloc[%d].Count %ld",i,NewDbg::GetCountM(i));
      printf("NewDbg.Malloc[%d].Bytes %ld",i,NewDbg::GetBytesM(i));
      }
   };

};*/

//void (* NewDbg::ErrorFunc)(NewDbg::Errors flag) = NULL;

void NewDbg::Inicializa_fmalloc(void)
{
for (int i=0;i<100;i++) 
   {
   CountMalloc[i]=0;
   BytesMalloc[i]=0;
   UsadoMalloc[i]=NO;
#ifdef SUPERMEMDEBUG
   BiggestCountMalloc[i]=0;
   BiggestBytesMalloc[i]=0;
#endif
   }
};



//NewDbg::Errors NewDbg::ErrorFlag = EF_OKAY;

const unsigned short NewDbg::CorrectMark = 0x1701;
const unsigned short NewDbg::CorrectMarkMalloc = 0x8057;

// NewDbg member functJons
int NewDbg::IsDynamic(void * ptr)
{
// get po1nter to header data

   AllocHeader * trueptr = (AllocHeader *)ptr;
   --trueptr;
   // return non-zero 1f marker 1s correct
   return (trueptr->Marker == CorrectMark);
};


long NewDbg::GetCountN()
{
return CountNew;
};

long NewDbg::GetBytesN()
{
return BytesNew;
};

long NewDbg::GetCountM(int n)
{
return CountMalloc[n];
};

long NewDbg::GetBytesM(int n)
{
return BytesMalloc[n];
};

void NewDbg::ShowStatus()
{
#ifdef CHECKPOINTS_EN_MALLOC
Checkpoint_control(1,"NewDbg::ShowStatus");
Checkpoint("NewDbg.  New .Count",NewDbg::GetCountN());
Checkpoint("NewDbg.  New .Bytes",NewDbg::GetBytesN());
Checkpoint("NewDbg.  New .MaxCount",NewDbg::BiggestCountNew);
Checkpoint("NewDbg.  New .MaxBytes",NewDbg::BiggestBytesNew);

for (int i=0;i<100;i++)
   {
   if (NewDbg::UsadoMalloc[i]==SI)
      {
      Checkpoint(4,"NewDbg.Malloc[",i,"].Count ",NewDbg::GetCountM(i));
      Checkpoint(4,"NewDbg.Malloc[",i,"].Bytes ",NewDbg::GetBytesM(i));
#ifdef SUPERMEMDEBUG
      Checkpoint(4,"NewDbg.Malloc[",i,"].MaxCount ",NewDbg::BiggestCountMalloc[i]);
      Checkpoint(4,"NewDbg.Malloc[",i,"].MaxBytes ",NewDbg::BiggestBytesMalloc[i]);
#endif
      }
   };
Checkpoint_control(2,"NewDbg::ShowStatus");
#endif
#ifdef PRINTF_EN_NEWDBG
printf("NewDbg.  New .Count",NewDbg::GetCountN());
printf("NewDbg.  New .Bytes",NewDbg::GetBytesN());
for (int i=0;i<100;i++)
   {
   if (NewDbg::UsadoMalloc[i]==SI)
      {
      printf("NewDbg.Malloc[%d].Count %ld",i,NewDbg::GetCountM(i));
      printf("NewDbg.Malloc[%d].Bytes %ld",i,NewDbg::GetBytesM(i));
      }
   };
#endif
};

/*
NewDbg::Errors NewDbg::GetError()
{
return ErrorFlag;
};

void NewDbg::ClearError()
{
ErrorFlag = NewDbg::EF_OKAY;
};

void NewDbg::InstallHandler (void (* func)(Errors flag))
{
ErrorFunc = func;
};

void NewDbg::ReportError(Errors err)
{
// set current error code
ErrorFlag = err;
//Checkpoint("ErrorFlag",ErrorFlag);
// if a handler funct10n is assigned. col 1 1 t
if (ErrorFunc != NULL) ErrorFunc(ErrorFlag);
};


//	- - - _ _ _
// new_handler operators new cnd delete
// - - - _ _ _ _ _ _ -

void ( * _new_handler)() = NULL;

void ( * set_new_handler(void ( * handler)()))()
{
// save current po1nter for return
void (* result)() = _new_handler;

// asstgn user funct10n to _new_handler
_new_handler = handler;
return result;
}
*/

void * operator new (size_t size)
{
// 1f there-s an error. don't allocate
//if (NewDbg::ErrorFlag != NewDbg::EF_OKAY)
//     return NULL;

// catch attempts to allocate zero hytes
if (size == 0u)
   {
//   NewDbg::ReportError(NewDbg::EF_ZEROSIZE);
#ifdef CHECKPOINTS_EN_MALLOC
   Checkpoint("NewDbg:new:: Alocatea 0 ?");
#endif
   return NULL;
   };

// calculate stze of allocat10n plus header
size_t actualsize =  size + sizeof(NewDbg::AllocHeader);

// call walloc to allocate memory
//Checkpoint("new ->",size);
struct NewDbg::AllocHeader * temp = (NewDbg::AllocHeader *)malloc(actualsize);

// a NULL pofnter tndtcates allocatton fatiure
if (temp == NULL)
   {
   // report that allocatton fafled
//   NewDbg::ReportError (NewDbg::EF_NOTALLOC);
#ifdef CHECKPOINTS_EN_MALLOC
   Checkpoint("NewDbg:new:: El new devuelve NULL");
#endif
   // call _new_handler 1f 1t tsn't NULL
//   if (_new_handler != NULL) _new_handler();
   return NULL;
   };

// set values In header
temp->Marker = NewDbg::CorrectMark;
temp->Bytes = size;

// 1ncrement track1ng vartsbles
++NewDbg::CountNew;
NewDbg::BytesNew += size;

#ifdef SUPERMEMDEBUG
if (NewDbg::BytesNew>NewDbg::BiggestBytesNew) NewDbg::BiggestBytesNew=NewDbg::BytesNew;
if (NewDbg::CountNew>NewDbg::BiggestCountNew) NewDbg::BiggestCountNew=NewDbg::CountNew;
#endif

// set temp to actual data (past header)
temp++;

return temp;

/*if (size == 0u)
   {
   Checkpoint("Intenta un new 0 !!!");
   return NULL;
   };
//size_t actualsize =  size + sizeof(NewDbg::AllocHeader);
size_t actualsize =  size + 4*sizeof(char);
NewDbg::AllocHeader * temp = (NewDbg::AllocHeader *)malloc(actualsize);

if (temp == NULL)
   {
   Checkpoint("El new devuelve NULL");
   return NULL;
   };

NewDbg::Count++;
NewDbg::Bytes += size;
char huge * pc=(char huge *)temp;
pc+=4;
return pc;
*/
}


void operator delete (void * ptr)
{
// if there's an error don t allocate
//if (NewDbg::ErrorFlag != NewDbg::EF_OKAY) return;

if (ptr==NULL)
   {
#ifdef CHECKPOINTS_EN_MALLOC
   Checkpoint("NewDbg:delete:: Quiere borrar un NULL !!");
#endif
   return;
   };
// get pointer to beg1nn ng of dato
NewDbg::AllocHeader * trueptr = (NewDbg::AllocHeader *)ptr;

// back up to start of header
--trueptr;


// verify that thrs IS an allocated pointer  
if (trueptr->Marker != NewDbg::CorrectMark)
//   NewDbg::ReportError(NewDbg::EF_INVALID );
   {
//    Checkpoint("NewDbg:delete:: No es un puntero o ya estaba borrado");
#ifdef CHECKPOINTS_EN_MALLOC
   if (trueptr->Marker==NewDbg::CorrectMarkMalloc) Checkpoint("NewDbg:ffree:: Intenta delete en vez de ffree !!");
      else Checkpoint("NewDbg:ffree:: No es un puntero o ya estaba borrado");
#endif
   }
  else
   {
   // reverse the bit in the 
   // maker so this  block cannot be deleted again
   trueptr->Marker = ~NewDbg::CorrectMark;

   // reduce total bytes allocated by size
   // of this block
   NewDbg :: BytesNew -= trueptr->Bytes;

// If the number of bytes a11ocated is
// less than O something went wrong
   if (NewDbg::BytesNew < 0)
      {
//      NewDbg::ReportError(NewDbg::EF_UNDERFLOW);
#ifdef CHECKPOINTS_EN_MALLOC
      Checkpoint("NewDbg:delete:: ha deleteado demasiado (<0 bytes alocateados)");
#endif
      }
     else
      {
      // tf the count equals zero, too
      //do Many deletions hove occurred
      if ( NewDbg::CountNew == 0)
          {
//          NewDbg::ReportError(NewDbg::EF_TOOMANY);
#ifdef CHECKPOINTS_EN_MALLOC
          Checkpoint("NewDbg:delete:: Mas deletes que news !");
#endif
          }
         else
          {
          // decrement number of allocation
          --NewDbg::CountNew;
          // free the pointer
//          Checkpoint("delete ->",trueptr->Bytes);
          free(trueptr);
          }
      }
   }


/*if (ptr==NULL) return;
NewDbg::Count--;
NewDbg::AllocHeader * trueptr = (NewDbg::AllocHeader *)ptr;
char huge *pc=(char huge *)ptr;
pc-=4;

// back up to start of header
--trueptr;
free(pc);
*/
}; 
void huge *fmalloc(unsigned long size,int id)
{
// catch attempts to allocate zero hytes
if (size == 0u)
   {
//   NewDbg::ReportError(NewDbg::EF_ZEROSIZE);
#ifdef CHECKPOINTS_EN_MALLOC
   Checkpoint("NewDbg:fmalloc:: Alocatea 0 ? . ID",id);
#endif
   return NULL;
   };

// calculate stze of allocat10n plus header
unsigned long actualsize =  size + sizeof(NewDbg::AllocHeaderM);

// call walloc to allocate memory
//Checkpoint("fmalloc ->",size);
//NewDbg::AllocHeaderM far * temp = (NewDbg::AllocHeaderM far *)malloc(actualsize);
NewDbg::AllocHeaderM huge * temp = (NewDbg::AllocHeaderM huge *)malloc(actualsize);
// a NULL pofnter tndtcates allocatton fatiure
if (temp == NULL)
   {
   // report that allocatton fafled
//   NewDbg::ReportError (NewDbg::EF_NOTALLOC);
#ifdef CHECKPOINTS_EN_MALLOC
   Checkpoint("NewDbg:fmalloc:: El fmalloc devuelve NULL . ID",id);
#endif
   // call _new_handler 1f 1t tsn't NULL
//   if (_new_handler != NULL) _new_handler();
   return NULL;
   };

// set values In header
temp->Marker = NewDbg::CorrectMarkMalloc;
temp->Bytes = size;
temp->Id=id;

// 1ncrement track1ng vartsbles
++NewDbg::CountMalloc[id];
NewDbg::BytesMalloc[id] += size;
NewDbg::UsadoMalloc[id]=SI; 

#ifdef SUPERMEMDEBUG
if (NewDbg::BytesMalloc[id]>NewDbg::BiggestBytesMalloc[id]) NewDbg::BiggestBytesMalloc[id]=NewDbg::BytesMalloc[id];
if (NewDbg::CountMalloc[id]>NewDbg::BiggestCountMalloc[id]) NewDbg::BiggestCountMalloc[id]=NewDbg::CountMalloc[id];
#endif
// set temp to actual data (past header)
temp++;
#ifdef MACROMEM_DEBUG
Checkpoint("fmalloc : ",(void *)temp);
Checkpoint("tamao : ",(long)(size_t)((temp-1)->Bytes));
#endif
return temp;
}

void ffree(void huge *ptr)
{
if (ptr==NULL)
   {
#ifdef CHECKPOINTS_EN_MALLOC
   Checkpoint("NewDbg:ffree:: Quiere borrar un NULL !!");
#endif
   return;
   };

// get pointer to beg1nn ng of dato
//NewDbg::AllocHeaderM far* trueptr = (NewDbg::AllocHeaderM far*)ptr;
NewDbg::AllocHeaderM huge* trueptr = (NewDbg::AllocHeaderM huge*)ptr;
// back up to start of header
trueptr--;


// verify that thrs IS an allocated pointer
if (trueptr->Marker != NewDbg::CorrectMarkMalloc)
//   NewDbg::ReportError(NewDbg::EF_INVALID );
   {
#ifdef CHECKPOINTS_EN_MALLOC
   if (trueptr->Marker==NewDbg::CorrectMark) Checkpoint("NewDbg:ffree:: Intenta ffree en vez de delete !! . ID",trueptr->Id);
      else Checkpoint("NewDbg:ffree:: No es un puntero o ya estaba borrado . ID",trueptr->Id);
#endif
   }
  else
   {
   // reverse the bit in the
   // maker so this  block cannot be deleted again
   trueptr->Marker = ~NewDbg::CorrectMarkMalloc;

   // reduce total bytes allocated by size
   // of this block
   NewDbg :: BytesMalloc[trueptr->Id] -= trueptr->Bytes;

// If the number of bytes a11ocated is
// less than O something went wrong
   if (NewDbg::BytesMalloc[trueptr->Id] < 0)
      {
#ifdef CHECKPOINTS_EN_MALLOC
//      NewDbg::ReportError(NewDbg::EF_UNDERFLOW);
      Checkpoint("NewDbg:ffree:: ha borrado demasiado (<0 bytes alocateados) . ID",trueptr->Id);
#endif
      }
     else
      {
      // tf the count equals zero, too
      //do Many deletions hove occurred
      if ( NewDbg::CountMalloc[trueptr->Id] == 0)
          {
#ifdef CHECKPOINTS_EN_MALLOC
//          NewDbg::ReportError(NewDbg::EF_TOOMANY);
          Checkpoint("NewDbg:ffree:: Mas ffrees que fmalloc ! . ID",trueptr->Id);
#endif
          }
         else
          {
          // decrement number of allocation
          --NewDbg::CountMalloc[trueptr->Id];
//          if (NewDbg::CountMalloc[trueptr->Id]==0) NewDbg::UsadoMalloc[trueptr->Id]=NO;

          // free the pointer
//          Checkpoint("ffree ->",trueptr->Bytes);
#ifdef MACROMEM_DEBUG
            Checkpoint("ffree : ",(void *)ptr);
            Checkpoint("tamao : ",(long)(trueptr->Bytes));
#endif
          free(trueptr);
//          NewDbg::ShowStatus();
          }
      }
   }
};
#endif
