/**********************************************************************
    numeroe.cc   --  Una clase "NumeroE" que implementa un numero redondeado
                    y lleva un error de redondeo que se ajusta conforme se hacen
                    las cuentas
  
    RealNumbers  1.0
    Copyright (C) 1997  Antonio Larrosa Jimenez

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
***********************************************************************/


#include "numeroe.h"
#include "newdebug.h"
#include <stdio.h>
#include <stdlib.h>
#include "messbox.h"
#include "numfunc.h"

NumeroE::NumeroE()
{
Err=No_hay_error;
NumRed=new Numero;
Error=new Numero;
};

NumeroE::NumeroE(long l)
{
Err=No_hay_error;
NumRed=new Numero(l);
Error=new Numero;
};

NumeroE::NumeroE(NumeroE &a)
{
Err=a.Err;
NumRed=new Numero(*a.NumRed);
Error=new Numero(*a.Error);
};

NumeroE::NumeroE(NumeroZ &a)
{
Err=No_hay_error;
NumRed=new Numero(a);
Error=new Numero;
};

NumeroE::NumeroE(NumeroQ &a)
{
Err=No_hay_error;
NumRed=new Numero;
Error=new Numero;
NumeroE N(*a.Numerador);
NumeroE D(*a.Denominador);
operator =(N/D);
};

NumeroE::NumeroE(Numero &a)
{
Err=No_hay_error;
NumRed=new Numero(a);
Error =new Numero;
if (NumRed->Err==Cociente_periodico)
    {
    NumRed->Err=No_hay_error;
    ++(*Error);
    (*Error)>>=NumRed->nPD;
    };
};

NumeroE::~NumeroE()
{
if (NumRed!=NULL) delete NumRed;
if (Error!=NULL) delete Error;
};

NumeroE NumeroE::operator =(long l)
{
*NumRed=l;
*Error=0L;
return (*this);
};

NumeroE NumeroE::operator =(char *s)    
{
if (Es_un_numero_correcto(s,NumRed->Base,"-:.")==NO) return (*this);
Err=No_hay_error;
char *pc=s;
while ((*pc!=0)&&(*pc!=':')&&(*pc!=''))
    {
    pc++;
    };
char c=*pc;
*pc=0;
(*NumRed)=s;
*pc=c;
if ((c==':')||(c==''))
    {
    pc++;
/*    if (strcmp(pc,"+oo")==0)
        {
        Err=Rango_mas_infinito;
        Error->Equal(0);
        }
       else if (strcmp(pc,"-oo")==0)
           {
           Err=Rango_menos_infinito;
           Error->Equal(0);
           }
          else
*/
           {
           (*Error)=pc;
           *Error=Error->Valor_Absoluto();           
           }; 
    };
return (*this);
};



NumeroE NumeroE::operator =(NumeroE a)
{
if (NumRed!=NULL)
    delete NumRed;
if (Error!=NULL) 
    delete Error;
Err=a.Err;
NumRed=new Numero(*(a.NumRed));
Error=new Numero(*(a.Error));
return (*this);
};

ostream &operator<<(ostream& s,NumeroE arg)
{
/*char *pstr=(char *)fmalloc(arg.Longitud()+1,0);
  arg.Convierte_a_cadena(pstr);
  s << pstr;
  ffree(pstr);
  return s;
*/
switch (arg.Err)
   {
   case (Division_x_cero) : s << "Division por cero" ; break;
   case (Rango_infinito) : s << "( -Infinito , +Infinito )";break;
   case (Rango_mas_infinito) : s << "[ " << *(arg.NumRed) << "" << *(arg.Error) << " , +Infinito )";break;
   case (Rango_menos_infinito):s << "( -Infinito , " << *(arg.NumRed) << "" << *(arg.Error) << " ]";break;
   default : s << *(arg.NumRed) << "" << *(arg.Error) << "  [ " << arg.Minimo_valor_posible() << " , " << arg.Maximo_valor_posible() << " ]";
   };
return s;
};


void NumeroE::Convierte_a_cadena(char *s)  
{
NumRed->Convierte_a_cadena(s);
char *pc=s;
while (*pc!=0) pc++;
*pc='';
pc++;
Error->Convierte_a_cadena(pc);
};

void NumeroE::Cambia_signo(void)
{
(*NumRed).Cambia_signo();
};

NumeroE NumeroE::operator ++(void)
{
++(*NumRed);
return (*this);
};


NumeroE NumeroE::operator --(void)
{
--(*NumRed);
return (*this);
};


NumeroE NumeroE::operator ++(int)
{
NumeroE Backup(*this);
++(*NumRed);
return Backup;
};


NumeroE NumeroE::operator --(int)
{
NumeroE Backup(*this);
--(*NumRed);
return Backup;
};


void NumeroE::operator <<=(ulong l)
{
  (*NumRed)<<=l;
  (*Error)<<=l;
};


void NumeroE::operator >>=(ulong l)
{
  (*NumRed)>>=l;
  (*Error)>>=l;
};



NumeroE NumeroE::operator +(NumeroE &b)
{
NumeroE Resultado;
if ((Err==Rango_infinito)||(b.Err==Rango_infinito))
    {
    Resultado.Err=Rango_infinito;
    return Resultado;
    };
//*Resultado.NumRed=(*NumRed)+(*b.NumRed);
//*Resultado.Error=(*Error)+(*b.Error);
if ((Err==Rango_menos_infinito)&&(Err==Rango_mas_infinito))
    {
    Resultado.Err=Rango_infinito;
    return Resultado;
    }
if ((Err==Rango_mas_infinito)&&(Err==Rango_menos_infinito))
    {
    Resultado.Err=Rango_infinito;
    return Resultado;
    };
*Resultado.NumRed=(*NumRed)+(*b.NumRed);
*Resultado.Error=(*Error)+(*b.Error);
if ((Err==No_hay_error)&&(Err==No_hay_error))
   {
   Resultado.Err=No_hay_error;
   }
  else
   {
   if (Err!=No_hay_error)
      {
      switch (Err) {
         case (Rango_mas_infinito) : Resultado.Err=Rango_mas_infinito;break;
         case (Rango_menos_infinito):Resultado.Err=Rango_menos_infinito;break;
         default : Resultado.Err=Err;
         };
     }
     else
      switch (Err) {
         case (Rango_mas_infinito) : Resultado.Err=Rango_mas_infinito;break;
         case (Rango_menos_infinito):Resultado.Err=Rango_menos_infinito;break;
         default : Resultado.Err=Err;
         };

   };
return Resultado;
};


NumeroE NumeroE::operator -(NumeroE &b)
{
NumeroE Resultado;
if ((Err==Rango_infinito)||(b.Err==Rango_infinito))
    {
    Resultado.Err=Rango_infinito;
    return Resultado;
    };
if ((Err==Rango_menos_infinito)&&(b.Err==Rango_menos_infinito))
    {
    Resultado.Err=Rango_infinito;
    return Resultado;
    };
if ((Err==Rango_mas_infinito)&&(b.Err==Rango_mas_infinito))
    {
    Resultado.Err=Rango_infinito;
    return Resultado;
    };

*Resultado.NumRed=(*NumRed)-(*b.NumRed);
*Resultado.Error=(*Error)+(*b.Error);
Resultado.Err=Err;

return Resultado;
};

NumeroE NumeroE::operator -(void)
{
NumeroE Resultado(*this);
Resultado.Cambia_signo();
return Resultado;
};

NumeroE NumeroE::operator *(NumeroE &b)
{
NumeroE Resultado;
*Resultado.NumRed=(*NumRed)*(*b.NumRed);
Numero temp;
temp=((*b.NumRed)*(*Error)).Valor_Absoluto();
Numero temp2;
temp2=((*Error)*(*b.Error)).Valor_Absoluto();
*Resultado.Error=((*NumRed)*(*b.Error))+temp+temp2;
return Resultado;
};


NumeroE NumeroE::operator /(NumeroE &b)
{
NumeroE Resultado;
Numero Cero;
if ((*b.NumRed==Cero)&&(*b.Error==Cero))  // b caso (6)
    {
    Resultado.Err=Division_x_cero;
    return Resultado;
    };
if ((*NumRed==Cero)&&(*Error==Cero))    // a caso (6)
    {
    if (b.Puede_ser(Cero)) Resultado.Err=Posible_Division_x_cero;  // b caso (2-3-4)
    return Resultado;                        // b caso (1)(5)
    };
Numero bmax=b.Maximo_valor_posible();
Numero bmin=b.Minimo_valor_posible();
if ((bmin*bmax)<Cero)      // b caso (3)
    {
    Resultado.Err=Rango_infinito;
    return Resultado;    
    };

Numero amax=Maximo_valor_posible();
Numero amin=Minimo_valor_posible();
NumeroE CotaSuperiorE;
NumeroE CotaInferiorE;

if ((amin*amax)<Cero)      // a caso (3)
    {
    if (b.Puede_ser(Cero))   // b caso (2-3-4)
        {
        Resultado.Err=Rango_infinito;
        return Resultado;
        };
    if (b.Es_positivo())   //  b caso (5)
        {
        CotaInferiorE=Divide_dos_numeros(amin,bmin);
        CotaSuperiorE=Divide_dos_numeros(amax,bmin);
        }
       else                // b caso (1)
        {
        CotaInferiorE=Divide_dos_numeros(amax,bmax);
        CotaSuperiorE=Divide_dos_numeros(amin,bmax);
        };
    }
   else
    if (amax<Cero)  // a caso (1)
        {
        if (bmax<=Cero)  
            {
            CotaInferiorE=Divide_dos_numeros(amax,bmin);
            if (bmax<Cero)  // b caso (1)
                {
                CotaSuperiorE=Divide_dos_numeros(amin,bmax);
                }
               else         // b caso (2)
                {
                Resultado.Err=Rango_mas_infinito;
                };
            }
           else
            {
            CotaSuperiorE=Divide_dos_numeros(amax,bmax);
            if (bmin>Cero)  // b caso (5)
                {
                CotaInferiorE=Divide_dos_numeros(amin,bmin);
                }
               else         // b caso (4)
                {
                Resultado.Err=Rango_menos_infinito;
                };
            };
        }
   else 
    if (amin>Cero)  // a caso (5)
        {
        if (bmax<=Cero)  
            {
            CotaSuperiorE=Divide_dos_numeros(amin,bmin);
            if (bmax<Cero)  // b caso (1)
                {
                CotaInferiorE=Divide_dos_numeros(amax,bmax);
                }
               else         // b caso (2)
                {
                Resultado.Err=Rango_menos_infinito;
                };
            }
           else
            {
            CotaInferiorE=Divide_dos_numeros(amin,bmax);
            if (bmin>Cero)  // b caso (5)
                {
                CotaSuperiorE=Divide_dos_numeros(amax,bmin);
                }
               else         // b caso (4)
                {
                Resultado.Err=Rango_mas_infinito;
                };
            };
        }
   else
    if (amin==Cero) // a caso (4)
        {
        if (bmax<=Cero)  
            {
            if (bmax<Cero)  // b caso (1)
                {
                CotaInferiorE=Divide_dos_numeros(amax,bmax);
		//    CotaSuperiorE=0;
                }
               else         // b caso (2)
                {
	        //    CotaSuperiorE=0;
                Resultado.Err=Rango_menos_infinito;
                };
            }
           else
            {
            if (bmin>Cero)  // b caso (5)
                {
                CotaSuperiorE=Divide_dos_numeros(amax,bmin);
                //    CotaInferiorE=0;
                }
               else         // b caso (4)
                {
		//    CotaInferiorE=0;
                Resultado.Err=Rango_mas_infinito;
                };
            };
        }
   else
    if (amax==Cero) // a caso (2)
        {
        if (bmax<=Cero)  
            {
            if (bmax<Cero)  // b caso (1)
                {
                CotaSuperiorE=Divide_dos_numeros(amin,bmax);
		//    CotaInferiorE=0;
                }
               else         // b caso (2)
                {
	        //    CotaInferiorE=0;
                Resultado.Err=Rango_mas_infinito;
                };
            }
           else
            {
            if (bmin>Cero)  // b caso (5)
                {
                CotaInferiorE=Divide_dos_numeros(amin,bmin);
                //    CotaSuperiorE=0;
                }
               else         // b caso (4)
                {
		//    CotaSuperiorE=0;
                Resultado.Err=Rango_menos_infinito;
                };
            };
        };

switch (Resultado.Err)
    {
    case (Rango_mas_infinito) :
                     Resultado=CotaInferiorE;                 
                     Resultado.Err=Rango_mas_infinito;
                     break;
    case (Rango_menos_infinito) :
                     Resultado=CotaSuperiorE;
                     Resultado.Err=Rango_menos_infinito;
                     break;
    default : 
                     Numero CotaInf;
                     Numero CotaSup;
                     CotaInf=CotaInferiorE.Minimo_valor_posible();
                     CotaSup=CotaSuperiorE.Maximo_valor_posible();
                     *Resultado.NumRed=CotaInf+CotaSup;
                     Numero Dos;++Dos;++Dos;
                     *Resultado.NumRed=(*Resultado.NumRed)/Dos;
   // En realidad deberia hacer la siguiente linea en vez de las 3 anteriores
  // pero haciendo las otras tres, el error cometido es menor                  
              //*Resultado.NumRed=(*NumRed)/(*b.NumRed);
                     Numero Err1;
                     Numero Err2;
                     Err1 = CotaSup-(*Resultado.NumRed);
                     Err2 = (*Resultado.NumRed)-CotaInf;
                     if (Err1>Err2) *Resultado.Error=Err1;
                         else *Resultado.Error=Err2;
    };
return Resultado;
};

/*
-----------------------------------------------------------------------------
  Rangos de posibles
   valores de A y B      A < B    A > B    A <= B   A >= B   A == B   A != B
-----------------------------------------------------------------------------
   ___A___          :    QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS
        ---B---

        ___A___     :    QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS
   ---B---

 ___A___            :      SI       NO       SI       NO       NO       SI
          ---B--- 

          ___A___   :      NO       SI       NO       SI       NO       SI
 ---B---

   _____A_____      :    QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS
     ---B---

     ___A___        :    QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS   QUIZAS
   -----B-----

-----------------------------------------------------------------------------
  Rangos de posibles
   valores de A y B      A < B    A > B    A <= B   A >= B   A == B   A != B
-----------------------------------------------------------------------------

  ___A___           :    QUIZAS     NO       SI     QUIZAS   QUIZAS   QUIZAS
         |---B---

          ___A___   :      NO     QUIZAS   QUIZAS     SI     QUIZAS   QUIZAS
  ---B---|

     A.             :      NO       NO       SI       SI       SI       NO
     B.
*/


int NumeroE::operator <(NumeroE &b)
{
Numero bmax=b.Maximo_valor_posible();
Numero bmin=b.Minimo_valor_posible();
if (Maximo_valor_posible()<bmin) return SI;
if (Minimo_valor_posible()>=bmax) return NO;
return QUIZAS;
};


int NumeroE::operator >(NumeroE &b)
{
Numero bmax=b.Maximo_valor_posible();
Numero bmin=b.Minimo_valor_posible();
if (Minimo_valor_posible()>bmax) return SI;
if (Maximo_valor_posible()<=bmin) return NO;
return QUIZAS;
};


int NumeroE::operator <=(NumeroE &b)
{
Numero bmax=b.Maximo_valor_posible();
Numero bmin=b.Minimo_valor_posible();
if (Minimo_valor_posible()>bmax) return NO;
if (Maximo_valor_posible()<=bmin) return SI;
return QUIZAS;
};


int NumeroE::operator >=(NumeroE &b)
{
Numero bmin=b.Minimo_valor_posible();
Numero bmax=b.Maximo_valor_posible();
if (Maximo_valor_posible()<bmin) return NO;
if (Minimo_valor_posible()>=bmax) return SI;
return QUIZAS;
};


int NumeroE::operator ==(NumeroE &b)
{
Numero bmin=b.Minimo_valor_posible();
Numero bmax=b.Maximo_valor_posible();
if (Maximo_valor_posible()<bmin) return NO;
if (Minimo_valor_posible()>bmax) return NO;
if ((bmin==bmax)&&(Maximo_valor_posible()==bmin)
                              &&(Minimo_valor_posible()==bmin)) return SI;
return QUIZAS;
};


int NumeroE::operator !=(NumeroE &b)
{
Numero bmin=b.Minimo_valor_posible();
Numero bmax=b.Maximo_valor_posible();
if (Maximo_valor_posible()<bmin) return SI;
if (Minimo_valor_posible()>bmax) return SI;
if ((bmin==bmax)&&(Maximo_valor_posible()==bmin)
                              &&(Minimo_valor_posible()==bmin)) return NO;
return QUIZAS;
};

ulong NumeroE::Longitud(void)
{
return NumRed->Longitud()+Error->Longitud()+1;
};

Numero NumeroE::Minimo_valor_posible(void)
{
return (*NumRed)-(*Error);
};

Numero NumeroE::Maximo_valor_posible(void)
{
return (*NumRed)+(*Error);
};

bool NumeroE::Puede_ser(Numero &a)
{
   if (Minimo_valor_posible()>a) return NO;
   if (Maximo_valor_posible()<a) return NO;
   return SI;
};

bool NumeroE::Es_positivo(void)
{
    Numero Cero;
    if (*NumRed>Cero) 
        {
        if (*NumRed<*Error) return QUIZAS;
        return SI;
        };
    if (*NumRed<Cero)
        {
        if (((*NumRed).Valor_Absoluto())<*Error) return QUIZAS;
        }
       else // *NumRed==0
        if (*Error!=Cero) return QUIZAS;
    return NO;
};

bool NumeroE::Es_negativo(void)
{
    Numero Cero;
    if (*NumRed<Cero) 
        {
        if (((*NumRed).Valor_Absoluto())<*Error) return QUIZAS;
        return SI;
        };
    if (*NumRed>Cero)
        {
        if (*NumRed<*Error) return QUIZAS;
        }
       else
        if (*Error!=Cero) return QUIZAS;
    return NO;
};

NumeroE NumeroE::Divide_dos_numeros(Numero &a,Numero &b)
{
NumeroE Resultado;
*Resultado.NumRed=a/b;
if (Resultado.NumRed->Err==Cociente_periodico)
    {
/* Si el cociente es periodico, hay un pequeo error que hay que sealar */
    ++(*Resultado.Error);
    (*Resultado.Error)>>=(Resultado.NumRed->nPD);
    };
return Resultado;
};

void NumeroE::Precision(ulong cuantos_decimales_dejar)
{
NumRed->Precision(cuantos_decimales_dejar);
Numero BakError(*Error);
Error->Precision(cuantos_decimales_dejar);
if (*Error<BakError)  // El error no puede disminuir !!
    {
    Numero Uno;++Uno;
    Uno>>=Error->nPD;
    *Error=*Error+Uno;
    };
};





